Subject: schema: "recognize" != "support" != "implement"

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Tue, 10 Dec 2002 10:35:06 -0800

In re-reading the existing "core" document and our I-Ds,
it seems that the use of the terms "recognize", "support",
and "implement" are used inconsistently.

In my eyes, "recognize" and "support" are generally not
equivalent terms.  That is, one can recognize an attribute
type without supporting that attribute type.  And while I
generally view "implement" as equivalent to "support",
one could argue that as must implement recognition,
its ambiguous.

Hence, I suggest that we use the term "recognize" to
mean that the implementation need only to recognize the
element in protocol exchanges but need not otherwise
support the element and that we use the term "support"
to mean that the implementation is not only recognize
the element in protocol exchanges but is also to
otherwise support the element.

This came up as I was reading [schema]:
>   There is no requirement that servers implement the following
>   Attribute Types:            
>       knowledgeInformation
>       searchGuide
>       teletexTerminalIdentifier
>   An LDAP server implementation SHOULD recognize the rest of the
>   Attribute Types described in this section.

As I read RFC 2252/2256, there is no requirement for servers
to "support" any of these attribute types but there is a
requirement that they "recognize" these attribute types.

RFC 2252 said:
> Servers SHOULD also recognize all the attributes from section 5
> of [12] (RFC2256).

Even where RFC 2252 said:
> All LDAP server implementations MUST recognize the attribute types
> defined in this section.

It didn't mean "All LDAP servers MUST support...",  as RFC 2251
clearly stated:
   Entries MAY contain, among others, the following operational
   attributes, defined in [5].

That is, support of the operational attribute types was
OPTIONAL but recognition of the types was REQUIRED.

So, I'm thinking that [schema] statement:
This came up as I was reading [schema]:
>   There is no requirement that servers implement the following
>   Attribute Types:            
>       knowledgeInformation
>       searchGuide
>       teletexTerminalIdentifier

should be dropped.

>   An LDAP server implementation SHOULD recognize the rest of the
>   Attribute Types described in this section.

And this be reverted back to its RFC 2256 wording:
   An LDAP server implementation SHOULD recognize the attribute types
   described in this section.

And that a clarifying not be added:
   , but are not required to otherwise support them.

Kurt

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Tue, 10 Dec 2002 11:41:18 -0800

I note as well that the difference is evident by the 2251
language:
   The server MUST be capable of recognizing all the mandatory attribute
   type names...

which says the names MUST be recognized but doesn't say the
attributes of the type MUST be supported.

Kurt

---

From: "Chris Apple" <[email-masked]>
Date: Sat, 21 Dec 2002 01:57:34 -0500

I don't have a strong opinion about which terms actually will be used,
but I do recommend that the terms actually used have their intended
meaning defined explicitly somewhere in the related LDAPBIS I-Ds.

Wording similar to that Kurt used looks reasonable to me.

Chris Apple - Principal Architect

DSI Consulting, Inc.

mailto:[email-masked]

http://www.dsi-consulting.com

-----Original Message-----
From: [email-masked]
[mailto:[email-masked]] On Behalf Of Kurt D. Zeilenga
Sent: Tuesday, December 10, 2002 1:35 PM
To: [email-masked]
Subject: schema: "recognize" != "support" != "implement"

should be dropped.

Kurt